/*
 * =====================================================
 * (c) Rick van de Westelaken & Bram van der Vlist 2007
 * MasterClass Technology fall/winter 2007
 * =====================================================
 */

public class InitNN 
{
	int inputLayerSize = 2;
	int hiddenLayerSize = 2;
	int outputLayerSize = 1;
	public Layer inputLayer = new Layer();
	public Layer hiddenLayer = new Layer();
	public Layer outputLayer = new Layer();
	double[][] input;
	double[][] output;
	
	public void setInputs(double[][] inputValues){
		input = inputValues;
	}
	
	public void setOutputs(double[][] outputValues){
		output = outputValues;
	}
	
	public void createInputLayer() 
	{
		inputLayer.createNeurons(inputLayerSize, 0, hiddenLayerSize);
	}
	
	public void createHiddenLayer() 
	{
		hiddenLayer.createNeurons(hiddenLayerSize, inputLayerSize, outputLayerSize);
	}
	
	public void createOutputLayer() 
	{
		outputLayer.createNeurons(outputLayerSize, hiddenLayerSize, 0);
	}
	
	public void createSynapses()
	{
		for(int i=0; i<inputLayerSize; i++)
		{
			for(int j=0; j<hiddenLayerSize; j++){
				new Synapse(inputLayer.neurons[i], hiddenLayer.neurons[j],j,i );
			}
		}
		for(int i=0; i<hiddenLayerSize; i++)
		{
			for(int j=0; j<outputLayerSize; j++){
				new Synapse(hiddenLayer.neurons[i], outputLayer.neurons[j],j,i );
			}
		}
	}
	
	public void copyInput(int sample)
	{
		for(int i=0; i < inputLayerSize; i++)
		{
			inputLayer.neurons[i].output = input[sample][i];
		}
	}
	
	public double calcOutput()
	{
		double errorRate =0;
		for (int i=0; i<input.length; i++)
		{
			copyInput(i);
			hiddenLayer.computeOutputs();
			outputLayer.computeOutputs();
			
			System.out.println("");
			for (int j=0; j<outputLayerSize; j++ )
			{
				System.out.print(outputLayer.neurons[j].output);
				System.out.print(" ; ");
				
				if (output[i][j] - outputLayer.neurons[j].output > errorRate )
				{
					errorRate = (output[i][j] - outputLayer.neurons[j].output) ;
				}
			}
		}
		
		return (1-errorRate)*100;
	}
	
	public double[] copyOutputs(int sample){
		double[] currentOutputs = new double[outputLayerSize];
		for(int i=0; i < outputLayerSize; i++){
			currentOutputs[i] = output[sample][i];
		}
		return currentOutputs;
	}
	
	public void backProp(int epochs)
	{
		for (int i=0; i<epochs; i++)
		{
			for (int j =0; j<input.length; j++)
			{
				copyInput(j);
				hiddenLayer.computeOutputs();
				outputLayer.computeOutputs();
				outputLayer.computeBackpropDeltas(copyOutputs(j));
				hiddenLayer.computeBackpropDeltas();
				outputLayer.computeWeights();
				hiddenLayer.computeWeights();
			}
		}	
	}
	
	public double[][] getHiddenWeights()
	{
		double[][] weights;
		weights = hiddenLayer.getLWeights();
		return weights;
	}
	
	public double[][] getOutputWeights()
	{
		double[][] weights;
		weights = outputLayer.getLWeights();
		return weights;
	}
}
