/*
 * =====================================================
 * (c) Rick van de Westelaken & Bram van der Vlist 2007
 * MasterClass Technology fall/winter 2007
 * =====================================================
 */

public class Layer 
{
	int layerSize;	//number of neurons in layer
	Neuron[] neurons;
	
	/*
	 * creates a layer (array) of neurons with layer size s.
	 * neurons get the size of previous and next layer    
	 */
	public void createNeurons(int s, int prevs, int nexts) 
	{
		layerSize = s;
		neurons = new Neuron[s];
		for(int i=0; i<s; i++ )
		{
			neurons[i] = new Neuron(prevs, nexts);
		}
	}
	
	/*
	 * calls computeOutputs for every neuron in the layer
	 */
	public void computeOutputs()
	{
		for(int i=0; i<layerSize; i++)
		{
	    neurons[i].computeOutput();
		}
	}
	
	/*
	 * calls computeBackpropDeltas for every neuron in the output layer
	 */
	public void computeBackpropDeltas(double[] outputSamples)
	{
		for(int i=0; i<layerSize; i++)
		{
	    neurons[i].computeBackpropDelta(outputSamples[i]);
		}	
	}
	
	/*
	 * calls computeBackpropDeltas for every neuron in the hidden layer
	 */
	public void computeBackpropDeltas()
	{
		for(int i=0; i<layerSize; i++)
		{
	    neurons[i].computeBackpropDelta();
		}
	}
	
	/*
	 * calls computeWeights for every neuron in the layer
	 */
	public void computeWeights()
	{
		for(int i=0; i<layerSize; i++)
		{
	    neurons[i].computeWeight();
		}
	}
	
	
	public void updateMomentum(double newMomentum)
	{
		for(int i=0; i<layerSize; i++)
		{
	    neurons[i].momentum = newMomentum;
		}
	}
	
	public void updateLearningRate(double newLearningRate)
	{
		for(int i=0; i<layerSize; i++)
		{
	    neurons[i].learningRate = newLearningRate;
		}
	}
	
	public double[][] getLWeights()
	{
		double[][] lWeights = new double[layerSize][];
		for(int i=0; i<layerSize; i++)
		{
			lWeights[i]= neurons[i].getWeights();
		}
		return lWeights;
	}
}
