/*
 * =====================================================
 * (c) Rick van de Westelaken & Bram van der Vlist 2007
 * MasterClass Technology fall/winter 2007
 * =====================================================
 */

import lejos.pc.comm.*;
import java.io.*;

public class computerSideConnection extends Thread {

	NXTComm nxtComm = null;
	DataOutputStream dos = null;
	DataInputStream dis = null;
	boolean running = true;
	boolean recording = false;
	double[][] recordedValues = new double[100][50];
	int SampleNbr =-1;
	int counter =0;
	
	public computerSideConnection() {

	}

	public void makeConnection(String macAddress, String cType) {
		startNXT(macAddress, cType);
		start();
	}

	public double[][] getInputs(){
		double[][] newRecordedValues = new double[SampleNbr+1][50];
		for (int i=0;i<SampleNbr+1;i++){
			for (int j=0;j<50;j++){
				newRecordedValues[i][j]=recordedValues[i][j];
			}
		}
		return newRecordedValues;
	}
	
	public void run() {
		while (running && dis != null) {
			
			try {

				float inputValue = dis.readFloat();
				recordedValues[SampleNbr][counter] = (double)inputValue;
				counter ++;
			} catch (IOException ioe) {
			}
		}
		System.out.println("end of while dis");
	}

	public void startNXT(String address, String cType) {
		boolean opened = true;
		NXTInfo[] nxtInfo;

		if (cType == "usb") {
			nxtComm = NXTCommFactory.createNXTComm(NXTCommFactory.USB);
			nxtInfo = nxtComm.search(null, NXTCommFactory.USB);
			if (nxtInfo.length == 0) {
				System.out.println("No NXT Found");
				System.exit(1);
			}
			nxtComm.open(nxtInfo[0]);

		} else {
			nxtComm = NXTCommFactory.createNXTComm(NXTCommFactory.BLUETOOTH);
			nxtInfo = new NXTInfo[1];
			nxtInfo[0] = new NXTInfo("", address);
			System.out.println("Connecting to " + nxtInfo[0].btResourceString);

			opened = nxtComm.open(nxtInfo[0]);
			if (!opened) {
				System.out.println("Failed to open " + nxtInfo[0].name);
				System.exit(1);
			}
		}

		System.out.println("Connected to " + nxtInfo[0].btResourceString);
		InputStream is = nxtComm.getInputStream();
		OutputStream os = nxtComm.getOutputStream();

		dos = new DataOutputStream(os);
		dis = new DataInputStream(is);

	}

	public void StartRecording() {
		counter=0;
		SampleNbr++;
		recording = true;
		try {
			dos.writeInt(1);
			dos.flush();
			(new Thread() {
				public void run() {
					while (recording == true) {
						try {
							dos.writeInt(6);
							dos.flush();
							try {
								Thread.sleep(30);
							} catch (Exception e) {
							}
						} catch (IOException ioe) {
						}
					}
					try {
						dos.writeInt(2);
						dos.flush();
					} catch (IOException e) {
					}
				}
			}).start();
		} catch (IOException e) {
		}
	}

	public void StopRecording() {
		recording = false;

	}

	public void suicide() {

		try {
			if (dis != null)
				dis.close();
			if (nxtComm != null)
				nxtComm.close();
		} catch (IOException ioe) {
			System.out.println("IOException closing connection");
		}
		running = false;
	}
}
