/*
 * =====================================================
 * (c) Rick van de Westelaken & Bram van der Vlist 2007
 * MasterClass Technology fall/winter 2007
 * =====================================================
 */

public class PreProcess {
	int sampleNumber;
	public double[] calcNewArray(int[] rawData){
		sampleNumber = 50; // change the number of samples here
		double[] processedData = new double[sampleNumber];
		double[] rawProcessedData = new double[sampleNumber];
		
		//Check whether the length of raw data is bigger or smaller than 50 items
		if (rawData.length < sampleNumber){ //rawData contains less than 50 items
			for (int i=0; i< sampleNumber;i++){ rawProcessedData[i] = 0; }
			for (int i=0; i<rawData.length;i++){ rawProcessedData[i] = rawData[i]; }
		}
		else if (rawData.length > sampleNumber){ //rawData contains more than sampleNumber items
			double[] newXcoord = new double[rawData.length];
			double deltaFactor;
			int c =0;
			boolean foundValue;
			
			deltaFactor = (double)sampleNumber / (double)rawData.length;
			for (int i=0;i<rawData.length;i++){
				newXcoord[i] = ((double)i * deltaFactor);
			}
			
			rawProcessedData[0] = rawData[0];
			for (int i=1;i<sampleNumber-1;i++){
				foundValue=false;
				
				while (foundValue == false){
					if (newXcoord[c] <= i && newXcoord[c + 1] > i){
						rawProcessedData[i] = rawData[c] + ((((double)i - newXcoord[c]) / (newXcoord[c + 1] - newXcoord[c])) * (rawData[c +1]- rawData[c]));
						foundValue=true;
					}
					else {
						c++;
					}
				}
			}
			rawProcessedData[sampleNumber-1] = rawData[rawData.length -1];
		}
		
		//Start normalizing values
		double highestValue =0;
		double finalMFactor=0;
		for (int i=0;i< sampleNumber;i++){
			if (rawProcessedData[i] > highestValue){
				highestValue = rawProcessedData[i];
			}
		}
		finalMFactor = 1 / highestValue;
		for (int i=0;i< sampleNumber;i++){
			processedData[i] = rawProcessedData[i] * finalMFactor;
		}
		
		return processedData;
	}
}
