/*
 * =====================================================
 * (c) Rick van de Westelaken & Bram van der Vlist 2007
 * MasterClass Technology fall/winter 2007
 * =====================================================
 */

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import lejos.nxt.*;
import lejos.nxt.comm.BTConnection;
import lejos.nxt.comm.Bluetooth;
import lejos.nxt.comm.USBConnection;

public class RecSoundSamples extends Thread implements ButtonListener{
	
	PreProcess pp = new PreProcess();
	SoundSensor sound = new SoundSensor(SensorPort.S1,true);
	BTConnection btc = null;
	USBConnection usbc = null;
	DataInputStream dis = null;
	DataOutputStream dos = null;
	boolean connected = false;
	boolean running = true;
	boolean recording = false;
	
	public RecSoundSamples(){
		LCD.clear();
		LCD.drawString("Select how to", 2, 2);
		LCD.drawString("connect to the", 1, 3);
		LCD.drawString("computer", 4, 4);
		LCD.drawString("USB", 0, 7);
		LCD.drawString("Bluetooth", 7, 7);
		LCD.refresh();
		
		Button.LEFT.addButtonListener(this);
		Button.RIGHT.addButtonListener(this);		
	}
	
	public void buttonPressed(Button btn) {
		if (btn == Button.LEFT){
			if (connected == false){
				connectUSB();
			}
		}
		else if (btn == Button.RIGHT){
			if (connected == false){
				connectBT();
			}	
		}
	}
	
	public void buttonReleased(Button btn) {
		// nothing here
	}
	
	public void connectUSB(){
		//Procedure to run when USB is selected as connection method
		usbc = new USBConnection();
		LCD.clear();
		LCD.drawString("Connected by USB", 0, 4);
		LCD.refresh();

		try{
			InputStream is = usbc.openInputStream();
			OutputStream os = usbc.openOutputStream();
			dis = new DataInputStream(is);
			dos = new DataOutputStream(os);
		} catch (IOException e){
			// no exception handling
		}
		connected = true;
		LCD.clear();
		LCD.drawString("Connected", 4, 4);
		LCD.refresh();
	}
	
	public void connectBT(){
		//Procedure to run when Bluetooth is selected as connection method
		LCD.clear();
		LCD.drawString("Waiting", 5, 4);
		LCD.refresh();
		btc = Bluetooth.waitForConnection();
		
		try{
			InputStream is = btc.openInputStream();
			OutputStream os = btc.openOutputStream();
			dis = new DataInputStream(is);
			dos = new DataOutputStream(os);
		} catch (IOException e) {
			//No error handling
		}
		connected = true;
		LCD.clear();
		LCD.drawString("Connected", 4, 4);
		LCD.refresh();
	}
	
	public void run() {
		int[] recValues = new int[300];
		double[] procValues = new double[50];
		int recNbr=0;
		
		while (running == true) {
			while (connected == true){
				
				///*
				try {
					int inputValue = dis.readInt();
					if (inputValue == 9){suicide();} 
					if (inputValue == 1){recording = true;}
					if (inputValue == 2){recording = false;}
				}	
				catch (IOException ioe) {
						// no exeption handling
				}
				
				if (recording == true){	
					//read sensor values
					recValues[recNbr]=sound.readValue();
					recNbr++;
					if (recNbr > 299){
						recNbr=299;
					}
					LCD.clear();
					LCD.drawInt(recNbr, 9, 1);
					LCD.refresh();
				}
					
				if (recNbr > 0 && recording == false){
					int[] tmpValues = new int[recNbr];
					for (int i=0;i<recNbr;i++){
						tmpValues[i] = recValues[i];
					}
					procValues = pp.calcNewArray(tmpValues);
					
					LCD.clear();
					LCD.drawString("Waardes", 4, 2);
					LCD.drawInt(recNbr, 4, 3);
					LCD.refresh();
					
					try{
						for (int i=0;i<50;i++){
							dos.writeFloat((float)procValues[i]);
							dos.flush();
						}
					}catch(IOException e){
						//no exeption handling
					}
					
					recNbr=0;
					for (int i=0;i<300;i++){
						recValues[i]=0;
					}
				}
				try {sleep(10);} catch(Exception e){}
			}
			try {sleep(100);} catch(Exception e){}
		}
	}
	
	public void suicide() {
		running = false;
		try {
			dis.close();
			dos.close();
			btc.close();
			usbc.close();
		} catch (IOException e) {
		}
		LCD.clear();
	}
	
	public static void main(String[] args) {
		RecSoundSamples rss = new RecSoundSamples();
		rss.start();
	}

}
